/*
 * @Author       : Eleanor Mao
 * @Date         : 2024-04-10 09:14:31
 * @LastEditTime : 2024-04-10 09:14:31
 *
 * Copyright © RingCentral. All rights reserved.
 */


import jsYaml from 'js-yaml';
import { transformDSL } from './transform';

function compress(s: string, pre: string): string {
  s = unescape(encodeURIComponent(s));
  const arr = [];
  for (let i = 0; i < s.length; i++) {
    arr.push(s.charCodeAt(i));
  }
  // @ts-ignore
  const compressor = new Zopfli.RawDeflate(arr);
  const compressed = compressor.compress();
  // @ts-ignore
  return "http://www.plantuml.com/plantuml" + pre + encode64_(compressed);
}

export function loadYml(input: string): string {
  const definition = jsYaml.load(input);
  let outputValue = transformDSL(definition);
  return compress(outputValue, '/svg/');
}
